/*
Copyright 2002-2005 Jose Nazario  <jose@monkey.org>
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <sys/time.h>
#include <sys/resource.h>
#include <sys/types.h>
#include <sys/wait.h>

#include <libgen.h>
#include <paths.h>
#include <pwd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define SYSTRACE_ARGS 	"-Ua"
#ifdef LEARN
#define SYSTRACE_ARGS 	"-A"
#endif

const char version[] = "stsh version 0.3, copyright 2003 jose nazario.";

/*
 launches a systraced shell, using auto enforcement and the system policies.
 reads the user's preferred login shell, sets *shell -l ...
 */

int
main(int argc, char *argv[])
{
	char           *args[5];
	struct passwd  *pwd;
	uid_t 		u;

	u = getuid();
	pwd = getpwuid(u);
	endpwent();

	args[0] = "systrace";
	args[1] = SYSTRACE_ARGS;	/* learning */
	args[2] = pwd->pw_shell;	/* the user's real shell */
	args[3] = "-l";			/* login shell */
	args[4] = NULL;

	if (execv("/bin/systrace", args) < 0) {
		fprintf(stderr, "logging in failed.\n");
		return(EXIT_FAILURE);
	}
	/* NOTREACHED */
	return(EXIT_SUCCESS);
}
